const capitalize = str => (
  str.toLowerCase().replace(/[a-z]/, i => i.toUpperCase())
);
const addSettersToStr = (setters, str) => {
  return str.replace(/(\/\*\s*setters?\s*\*\/)/, '$1\n' + setters);
};

module.exports = (file) => {
  let temStr = file.contents.toString(); // 最后返回的字符串
  let setterString = []; // setters 字符串数组
  let matchData = ''; // 匹配的data
  matchData = /data\(\)\s*\{[\w\W]*return\s*\{[^\;]+/.exec(temStr)[0];
  matchData = matchData.replace(/(^(data\(\)\s*\{[\w\W]*return\s*) | \}$)/g, '');
  matchData = matchData.replace(/\{/, '');
  matchData = matchData.split(/\n/);
  matchData.shift();
  matchData.pop();
  matchData.forEach((item) => {
    const arr = item.split('\/\/');
    const dataName = /[^\s\:]+/.exec(arr[0])[0];
    const type = /[^\s]+/.exec(arr[1])[0];
    switch (type) {
      case 'val':
        setterString.push(
`set${capitalize(dataName)}(val) {
  this.${dataName} = val;
},`
        );
        break;
      case 'obj':
        setterString.push(
`set${capitalize(dataName)}(key, val) {
  this.${dataName}[key] = val;
},`
        );
        break;
      case 'bool':
        setterString.push(
`toggle${capitalize(dataName)}(val) {
  this.${dataName} = val;
},`
        );
        break;
      default:
        break;
    }
  });
  const setterLen = setterString.length;
  setterString[setterLen - 1] = setterString[setterLen - 1].substring(0, setterString[setterLen - 1].length - 1);
  setterString = setterString.join('\n');
  temStr = addSettersToStr(setterString, temStr);
  return new Buffer(temStr);
};